CharacterData (Java SE 26 & JDK 26)
Description: declaration: module: java.xml, package: org.w3c.dom, interface: CharacterData
Keywords: org.w3c.dom.CharacterData interface

# Interface CharacterData

All Superinterfaces:
  `Node`

All Known Subinterfaces:
  `CDATASection, Comment, Text`

public interface CharacterData extends Node
The `CharacterData` interface extends Node with a set of attributes and methods for accessing character data in the DOM. For clarity this set is defined here rather than on each object that uses these attributes and methods. No DOM objects correspond directly to `CharacterData`, though `Text` and others do inherit the interface from it. All `offsets` in this interface start from `0`.

As explained in the `DOMString` interface, text strings in the DOM are represented in UTF-16, i.e. as a sequence of 16-bit units. In the following, the term 16-bit units is used whenever necessary to indicate that indexing on CharacterData is done in 16-bit units.

See also the Document Object Model (DOM) Level 3 Core Specification.

Since:
  1.4, DOM Level 2

- ## Field Summary

  ### Fields declared in interface Node

  `ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_POSITION_CONTAINED_BY, DOCUMENT_POSITION_CONTAINS, DOCUMENT_POSITION_DISCONNECTED, DOCUMENT_POSITION_FOLLOWING, DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC, DOCUMENT_POSITION_PRECEDING, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NOTATION_NODE, PROCESSING_INSTRUCTION_NODE, TEXT_NODE`
  Modifier and Type
  Field
  Description
  `static final short`
  `ATTRIBUTE_NODE`
  The node is an `Attr`.
  `static final short`
  `CDATA_SECTION_NODE`
  The node is a `CDATASection`.
  `static final short`
  `COMMENT_NODE`
  The node is a `Comment`.
  `static final short`
  `DOCUMENT_FRAGMENT_NODE`
  The node is a `DocumentFragment`.
  `static final short`
  `DOCUMENT_NODE`
  The node is a `Document`.
  `static final short`
  `DOCUMENT_POSITION_CONTAINED_BY`
  The node is contained by the reference node.
  `static final short`
  `DOCUMENT_POSITION_CONTAINS`
  The node contains the reference node.
  `static final short`
  `DOCUMENT_POSITION_DISCONNECTED`
  The two nodes are disconnected.
  `static final short`
  `DOCUMENT_POSITION_FOLLOWING`
  The node follows the reference node.
  `static final short`
  `DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC`
  The determination of preceding versus following is implementation-specific.
  `static final short`
  `DOCUMENT_POSITION_PRECEDING`
  The second node precedes the reference node.
  `static final short`
  `DOCUMENT_TYPE_NODE`
  The node is a `DocumentType`.
  `static final short`
  `ELEMENT_NODE`
  The node is an `Element`.
  `static final short`
  `ENTITY_NODE`
  The node is an `Entity`.
  `static final short`
  `ENTITY_REFERENCE_NODE`
  The node is an `EntityReference`.
  `static final short`
  `NOTATION_NODE`
  The node is a `Notation`.
  `static final short`
  `PROCESSING_INSTRUCTION_NODE`
  The node is a `ProcessingInstruction`.
  `static final short`
  `TEXT_NODE`
  The node is a `Text` node.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `appendData(String arg)`
  Append the string to the end of the character data of the node.
  `void`
  `deleteData(int offset, int count)`
  Remove a range of 16-bit units from the node.
  `String`
  `getData()`
  The character data of the node that implements this interface.
  `int`
  `getLength()`
  The number of 16-bit units that are available through `data` and the `substringData` method below.
  `void`
  `insertData(int offset, String arg)`
  Insert a string at the specified 16-bit unit offset.
  `void`
  `replaceData(int offset, int count, String arg)`
  Replace the characters starting at the specified 16-bit unit offset with the specified string.
  `void`
  `setData(String data)`
  The character data of the node that implements this interface.
  `String`
  `substringData(int offset, int count)`
  Extracts a range of data from the node.

  ### Methods declared in interface Node

  `appendChild, cloneNode, compareDocumentPosition, getAttributes, getBaseURI, getChildNodes, getFeature, getFirstChild, getLastChild, getLocalName, getNamespaceURI, getNextSibling, getNodeName, getNodeType, getNodeValue, getOwnerDocument, getParentNode, getPrefix, getPreviousSibling, getTextContent, getUserData, hasAttributes, hasChildNodes, insertBefore, isDefaultNamespace, isEqualNode, isSameNode, isSupported, lookupNamespaceURI, lookupPrefix, normalize, removeChild, replaceChild, setNodeValue, setPrefix, setTextContent, setUserData`
  Modifier and Type
  Method
  Description
  `Node`
  `appendChild(Node newChild)`
  Adds the node `newChild` to the end of the list of children of this node.
  `Node`
  `cloneNode(boolean deep)`
  Returns a duplicate of this node, i.e., serves as a generic copy constructor for nodes.
  `short`
  `compareDocumentPosition(Node other)`
  Compares the reference node, i.e. the node on which this method is being called, with a node, i.e. the one passed as a parameter, with regard to their position in the document and according to the document order.
  `NamedNodeMap`
  `getAttributes()`
  A `NamedNodeMap` containing the attributes of this node (if it is an `Element`) or `null` otherwise.
  `String`
  `getBaseURI()`
  The absolute base URI of this node or `null` if the implementation wasn't able to obtain an absolute URI.
  `NodeList`
  `getChildNodes()`
  A `NodeList` that contains all children of this node.
  `Object`
  `getFeature(String feature, String version)`
  This method returns a specialized object which implements the specialized APIs of the specified feature and version, as specified in .
  `Node`
  `getFirstChild()`
  The first child of this node.
  `Node`
  `getLastChild()`
  The last child of this node.
  `String`
  `getLocalName()`
  Returns the local part of the qualified name of this node.
  `String`
  `getNamespaceURI()`
  The namespace URI of this node, or `null` if it is unspecified (see ).
  `Node`
  `getNextSibling()`
  The node immediately following this node.
  `String`
  `getNodeName()`
  The name of this node, depending on its type; see the table above.
  `short`
  `getNodeType()`
  A code representing the type of the underlying object, as defined above.
  `String`
  `getNodeValue()`
  The value of this node, depending on its type; see the table above.
  `Document`
  `getOwnerDocument()`
  The `Document` object associated with this node.
  `Node`
  `getParentNode()`
  The parent of this node.
  `String`
  `getPrefix()`
  The namespace prefix of this node, or `null` if it is unspecified.
  `Node`
  `getPreviousSibling()`
  The node immediately preceding this node.
  `String`
  `getTextContent()`
  This attribute returns the text content of this node and its descendants.
  `Object`
  `getUserData(String key)`
  Retrieves the object associated to a key on a this node.
  `boolean`
  `hasAttributes()`
  Returns whether this node (if it is an element) has any attributes.
  `boolean`
  `hasChildNodes()`
  Returns whether this node has any children.
  `Node`
  `insertBefore(Node newChild, Node refChild)`
  Inserts the node `newChild` before the existing child node `refChild`.
  `boolean`
  `isDefaultNamespace(String namespaceURI)`
  This method checks if the specified `namespaceURI` is the default namespace or not.
  `boolean`
  `isEqualNode(Node arg)`
  Tests whether two nodes are equal.
  `boolean`
  `isSameNode(Node other)`
  Returns whether this node is the same node as the given one.
  `boolean`
  `isSupported(String feature, String version)`
  Tests whether the DOM implementation implements a specific feature and that feature is supported by this node, as specified in .
  `String`
  `lookupNamespaceURI(String prefix)`
  Look up the namespace URI associated to the given prefix, starting from this node.
  `String`
  `lookupPrefix(String namespaceURI)`
  Look up the prefix associated to the given namespace URI, starting from this node.
  `void`
  `normalize()`
  Puts all `Text` nodes in the full depth of the sub-tree underneath this `Node`, including attribute nodes, into a "normal" form where only structure (e.g., elements, comments, processing instructions, CDATA sections, and entity references) separates `Text` nodes, i.e., there are neither adjacent `Text` nodes nor empty `Text` nodes.
  `Node`
  `removeChild(Node oldChild)`
  Removes the child node indicated by `oldChild` from the list of children, and returns it.
  `Node`
  `replaceChild(Node newChild, Node oldChild)`
  Replaces the child node `oldChild` with `newChild` in the list of children, and returns the `oldChild` node.
  `void`
  `setNodeValue(String nodeValue)`
  The value of this node, depending on its type; see the table above.
  `void`
  `setPrefix(String prefix)`
  The namespace prefix of this node, or `null` if it is unspecified.
  `void`
  `setTextContent(String textContent)`
  This attribute returns the text content of this node and its descendants.
  `Object`
  `setUserData(String key, Object data, UserDataHandler handler)`
  Associate an object to a key on this node.

- ## Method Details

  - ### getData

    String getData() throws DOMException
    The character data of the node that implements this interface. The DOM implementation may not put arbitrary limits on the amount of data that may be stored in a `CharacterData` node. However, implementation limits may mean that the entirety of a node's data may not fit into a single `DOMString`. In such cases, the user may call `substringData` to retrieve the data in appropriately sized pieces.
    Throws:
      `DOMException` - DOMSTRING_SIZE_ERR: Raised when it would return more characters than fit in a `DOMString` variable on the implementation platform.

  - ### setData

    void setData(String data) throws DOMException
    The character data of the node that implements this interface. The DOM implementation may not put arbitrary limits on the amount of data that may be stored in a `CharacterData` node. However, implementation limits may mean that the entirety of a node's data may not fit into a single `DOMString`. In such cases, the user may call `substringData` to retrieve the data in appropriately sized pieces.
    Throws:
      `DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised when the node is readonly.

  - ### getLength

    int getLength()
    The number of 16-bit units that are available through `data` and the `substringData` method below. This may have the value zero, i.e., `CharacterData` nodes may be empty.

  - ### substringData

    String substringData(int offset, int count) throws DOMException
    Extracts a range of data from the node.
    Parameters:
      `offset` - Start offset of substring to extract.
      `count` - The number of 16-bit units to extract.
    Returns:
      The specified substring. If the sum of `offset` and `count` exceeds the `length`, then all 16-bit units to the end of the data are returned.
    Throws:
      `DOMException` - INDEX_SIZE_ERR: Raised if the specified `offset` is negative or greater than the number of 16-bit units in `data`, or if the specified `count` is negative.
      DOMSTRING_SIZE_ERR: Raised if the specified range of text does not fit into a `DOMString`.

  - ### appendData

    void appendData(String arg) throws DOMException
    Append the string to the end of the character data of the node. Upon success, `data` provides access to the concatenation of `data` and the `DOMString` specified.
    Parameters:
      `arg` - The `DOMString` to append.
    Throws:
      `DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

  - ### insertData

    void insertData(int offset, String arg) throws DOMException
    Insert a string at the specified 16-bit unit offset.
    Parameters:
      `offset` - The character offset at which to insert.
      `arg` - The `DOMString` to insert.
    Throws:
      `DOMException` - INDEX_SIZE_ERR: Raised if the specified `offset` is negative or greater than the number of 16-bit units in `data`.
      NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

  - ### deleteData

    void deleteData(int offset, int count) throws DOMException
    Remove a range of 16-bit units from the node. Upon success, `data` and `length` reflect the change.
    Parameters:
      `offset` - The offset from which to start removing.
      `count` - The number of 16-bit units to delete. If the sum of `offset` and `count` exceeds `length` then all 16-bit units from `offset` to the end of the data are deleted.
    Throws:
      `DOMException` - INDEX_SIZE_ERR: Raised if the specified `offset` is negative or greater than the number of 16-bit units in `data`, or if the specified `count` is negative.
      NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.

  - ### replaceData

    void replaceData(int offset, int count, String arg) throws DOMException
    Replace the characters starting at the specified 16-bit unit offset with the specified string.
    Parameters:
      `offset` - The offset from which to start replacing.
      `count` - The number of 16-bit units to replace. If the sum of `offset` and `count` exceeds `length`, then all 16-bit units to the end of the data are replaced; (i.e., the effect is the same as a `remove` method call with the same range, followed by an `append` method invocation).
      `arg` - The `DOMString` with which the range must be replaced.
    Throws:
      `DOMException` - INDEX_SIZE_ERR: Raised if the specified `offset` is negative or greater than the number of 16-bit units in `data`, or if the specified `count` is negative.
      NO_MODIFICATION_ALLOWED_ERR: Raised if this node is readonly.